Overview | Package | Class | Tree | Deprecated | Index | Help
| J2EE1.4 SDK
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management.modelmbean
Class DescriptorSupport

    java.lang.Object
      javax.management.modelmbean.DescriptorSupport

All Implemented Interfaces:
  java.lang.Cloneable, Descriptor, java.io.Serializable

public class DescriptorSupport
extends java.lang.Object
implements Descriptor

This class represents the metadata set for a ModelMBean element. A descriptor is part of the ModelMBeanInfo, ModelMBeanNotificationInfo, ModelMBeanAttributeInfo, ModelMBeanConstructorInfo, and ModelMBeanParameterInfo.

A descriptor consists of a collection of fields. Each field is in fieldname=fieldvalue format. Field names are not case sensitive, case will be preserved on field values.

All field names and values are not predefined. New fields can be defined and added by any program. Some fields have been predefined for consistency of implementation and support by the ModelMBeanInfo, ModelMBeanAttributeInfo, ModelMBeanConstructorInfo, ModelMBeanNotificationInfo, ModelMBeanOperationInfo and ModelMBean classes.

See Also:
  Serialized Form

Constructor Summary
`DescriptorSupport()` Descriptor default constructor.
`DescriptorSupport(DescriptorSupport inDescr)` Descriptor constructor taking a Descriptor as parameter.
`DescriptorSupport(int initNumFields)` Descriptor constructor.
`DescriptorSupport(java.lang.String inStr)` Descriptor constructor taking an XML String.
`DescriptorSupport(java.lang.String[] fields)` Constructor taking fields in the fieldName=fieldValue format.
`DescriptorSupport(java.lang.String[] fieldNames, java.lang.Object[] fieldValues)` Constructor taking field names and field values.

Method Summary
`java.lang.Object` | `clone()` Returns a new Descriptor which is a duplicate of the Descriptor.
`java.lang.String[]` | `getFieldNames()` Returns all the fields names in the descriptor.
`java.lang.String[]` | `getFields()` Returns all the fields in the descriptor.
`java.lang.Object` | `getFieldValue(java.lang.String inFieldName)` Returns the value for a specific fieldname.
`java.lang.Object[]` | `getFieldValues(java.lang.String[] fieldNames)` Returns all the field values in the descriptor as an array of Objects.
`boolean` | `isValid()` Returns true if all of the fields have legal values given their names.
`void` | `removeField(java.lang.String fieldName)` Removes a field from the descriptor.
`void` | `setField(java.lang.String inFieldName, java.lang.Object fieldValue)` Sets the string value for a specific fieldname.
`void` | `setFields(java.lang.String[] fieldNames, java.lang.Object[] fieldValues)` Sets all Fields in the list to the new value with the same index in the fieldValue array.
`java.lang.String` | `toString()` Returns a human readable string representing the descriptor.
`java.lang.String` | `toXMLString()` Returns an XML String representing the descriptor.

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### DescriptorSupport

    public DescriptorSupport()

  Descriptor default constructor. Default initial descriptor size is 20. It will grow as needed.
  Note that the created empty descriptor is not a valid descriptor (the method `isValid` returns `false`)

### DescriptorSupport

    public DescriptorSupport(int initNumFields)
                      throws MBeanException,
                             RuntimeOperationsException

  Descriptor constructor. Takes as parameter the initial capacity of the Map that stores the descriptor fields. Capacity will grow as needed.
  Note that the created empty descriptor is not a valid descriptor (the method `isValid` returns `false`).

Parameters:
  `initNumFields` - The initial capacity of the Map that stores the descriptor fields.
Throws:
  `RuntimeOperationsException` - for illegal value for initNumFields (<= 0)
  `MBeanException` - Wraps a distributed communication Exception.

### DescriptorSupport

    public DescriptorSupport(DescriptorSupport inDescr)

  Descriptor constructor taking a Descriptor as parameter. Creates a new descriptor initialized to the values of the descriptor passed in parameter.

Parameters:
  `inDescr` - the descriptor to be used to initialize the constructed descriptor. If it is null or contains no descriptor fields, an empty Descriptor will be created.

### DescriptorSupport

    public DescriptorSupport(java.lang.String inStr)
                      throws MBeanException,
                             RuntimeOperationsException,
                             XMLParseException

  Descriptor constructor taking an XML String.

  The format of the XML string is not defined, but an implementation must ensure that the string returned by `toXMLString()` on an existing descriptor can be used to instantiate an equivalent descriptor using this constructor.

  In this implementation, all field values will be created as Strings. If the field values are not Strings, the programmer will have to reset or convert these fields correctly.

Parameters:
  `inStr` - An XML-formatted string used to populate this Descriptor. The format is not defined, but any implementation must ensure that the string returned by method `toXMLString` on an existing descriptor can be used to instantiate an equivalent descriptor when instantiated using this constructor.
Throws:
  `RuntimeOperationsException` - If the String inStr passed in parameter is null
  `XMLParseException` - XML parsing problem while parsing the input String
  `MBeanException` - Wraps a distributed communication Exception.

### DescriptorSupport

    public DescriptorSupport(java.lang.String[] fieldNames,
                             java.lang.Object[] fieldValues)
                      throws RuntimeOperationsException

  Constructor taking field names and field values. The array and array elements cannot be null.

Parameters:
  `fieldNames` - String array of field names. No elements of this array can be null.
  `fieldValues` - Object array of the corresponding field values. Elements of the array can be null. The `fieldValue` must be valid for the `fieldName` (as defined in method `isValid`)

  Note: array sizes of parameters should match. If both arrays are null or empty, then an empty descriptor is created.

Throws:
  `RuntimeOperationsException` - for illegal value for field Names or field Values. The array lengths must be equal. If the descriptor construction fails for any reason, this exception will be thrown.

### DescriptorSupport

    public DescriptorSupport(java.lang.String[] fields)

  Constructor taking fields in the fieldName=fieldValue format.

Parameters:
  `fields` - String array with each element containing a field name and value. If this array is null or empty, then the default constructor will be executed. Null strings or empty strings will be ignored.

  All field values should be Strings. If the field values are not Strings, the programmer will have to reset or convert these fields correctly.

  Note: Each string should be of the form fieldName=fieldValue.

Throws:
  `RuntimeOperationsException` - for illegal value for field Names or field Values. The field must contain an "=". "=fieldValue", "fieldName", and "fieldValue" are illegal. FieldName cannot be null. "fieldName=" will cause the value to be null. If the descriptor construction fails for any reason, this exception will be thrown.

Method Detail

### getFieldValue

    public java.lang.Object getFieldValue(java.lang.String inFieldName)
                                   throws RuntimeOperationsException

  Returns the value for a specific fieldname.

  Specified by:
    `getFieldValue` in interface `Descriptor`
  Parameters:
    `inFieldName` - The field name in question; if not found, null is returned.
  Returns:
    An Object representing the field value
  Throws:
    `RuntimeOperationsException` - for illegal value (null or empty string) for field Names.

### setField

    public void setField(java.lang.String inFieldName,
                         java.lang.Object fieldValue)
                  throws RuntimeOperationsException

  Sets the string value for a specific fieldname. The value must be valid for the field (as defined in method `isValid`). If the field does not exist, it is added at the end of the Descriptor. If it does exist, the value is replaced.

  Specified by:
    `setField` in interface `Descriptor`
  Parameters:
    `inFieldName` - The field name to be set. Must not be null or empty string.
    `fieldValue` - The field value to be set for the field name. Can be null or empty string.
  Throws:
    `RuntimeOperationsException` - for illegal value for field Names.

### getFields

    public java.lang.String[] getFields()

  Returns all the fields in the descriptor. The order is not the order in which the fields were set.

  Specified by:
    `getFields` in interface `Descriptor`
  Returns:
    String array of fields in the format fieldName=fieldValue. If there are no fields in the descriptor, then an empty String array is returned. If a fieldValue is not a String then the toString() method is called on it and its returned value is used as the value for the field enclosed in parenthesis.
  See Also:
    `setFields(java.lang.String[], java.lang.Object[])`

### getFieldNames

    public java.lang.String[] getFieldNames()

  Returns all the fields names in the descriptor. The order is not the order in which the fields were set.

  Specified by:
    `getFieldNames` in interface `Descriptor`
  Returns:
    String array of fields names. If the descriptor is empty, you will get an empty array.

### getFieldValues

    public java.lang.Object[] getFieldValues(java.lang.String[] fieldNames)

  Returns all the field values in the descriptor as an array of Objects. The returned values are in the same order as the fieldNames String array parameter.

  Specified by:
    `getFieldValues` in interface `Descriptor`
  Parameters:
    `fieldNames` - String array of the names of the fields that the values should be returned for.
    If the array is empty then an empty array will be returned.
    If the array is 'null' then all values will be returned. The order is not the order in which the fields were set.
    If a field name in the array does not exist, then null is returned for the matching array element being returned.
  Returns:
    Object array of field values. If the descriptor is empty, you will get an empty array.

### setFields

    public void setFields(java.lang.String[] fieldNames,
                          java.lang.Object[] fieldValues)
                   throws RuntimeOperationsException

  Sets all Fields in the list to the new value with the same index in the fieldValue array. Array sizes must match. The field value will be validated before it is set (by calling the method `isValid`). If it is not valid, then an exception will be thrown. If the arrays are empty, then no change will take effect.

  Specified by:
    `setFields` in interface `Descriptor`
  Parameters:
    `fieldNames` - String array of field names. The array and array elements cannot be null.
    `fieldValues` - Object array of the corresponding field values. The array cannot be null. Elements of the array can be null.
  Throws:
    `RuntimeOperationsException` - for illegal value for field Names or field Values. Neither can be null. The array lengths must be equal.
  See Also:
    `getFields()`

### clone

    public java.lang.Object clone()
                           throws RuntimeOperationsException

  Returns a new Descriptor which is a duplicate of the Descriptor.

  Specified by:
    `clone` in interface `Descriptor`
  Throws:
    `RuntimeOperationsException` - for illegal value for field Names or field Values. If the descriptor construction fails for any reason, this exception will be thrown.

### removeField

    public void removeField(java.lang.String fieldName)

  Removes a field from the descriptor.

  Specified by:
    `removeField` in interface `Descriptor`
  Parameters:
    `fieldName` - String name of the field to be removed. If the field is not found no exception is thrown.

### isValid

    public boolean isValid()
                    throws RuntimeOperationsException

  Returns true if all of the fields have legal values given their names.

  This implementation does not support interoperating with a directory or lookup service. Thus, conforming to the specification, no checking is done on the "export" field.

  Otherwise this implementation returns false if:

  - name and descriptorType fieldNames are not defined, or null, or empty, or not String
  - class, role, getMethod, setMethod fieldNames, if defined, are null or not String
  - persistPeriod, currencyTimeLimit, lastUpdatedTimeStamp, lastReturnedTimeStamp if defined, are null, or not a Numeric String or not a Numeric Value >= -1
  - log fieldName, if defined, is null, or not a Boolean or not a String with value "t", "f", "true", "false". These String values must not be case sensitive.
  - visibility fieldName, if defined, is null, or not a Numeric String or a not Numeric Value >= 1 and <= 4
  - severity fieldName, if defined, is null, or not a Numeric String or not a Numeric Value >= 0 and <= 6
  - persistPolicy fieldName, if defined, is null, or not a following String :
    "OnUpdate", "OnTimer", "NoMoreOftenThan", "Always", "Never". These String values must not be case sensitive.

  Specified by:
    `isValid` in interface `Descriptor`
  Returns:
    true if the values are legal.
  Throws:
    `RuntimeOperationsException` - If the validity checking fails for any reason, this exception will be thrown.

### toXMLString

    public java.lang.String toXMLString()

  Returns an XML String representing the descriptor.

  The format is not defined, but an implementation must ensure that the string returned by this method can be used to build an equivalent descriptor when instantiated using the constructor `DescriptorSupport(String inStr)`.

  Fields which are not String objects will have toString() called on them to create the value. The value will be enclosed in parentheses. It is not guaranteed that you can reconstruct these objects unless they have been specifically set up to support toString() in a meaningful format and have a matching constructor that accepts a String in the same format.

  If the descriptor is empty the following String is returned: <Descriptor></Descriptor>

  Returns:
    the XML string.
  Throws:
    `RuntimeOperationsException` - for illegal value for field Names or field Values. If the XML formated string construction fails for any reason, this exception will be thrown.

### toString

    public java.lang.String toString()

  Returns a human readable string representing the descriptor. The string will be in the format of "fieldName=fieldValue,fieldName2=fieldValue2,..."
  If there are no fields in the descriptor, then an empty String is returned.
  If a fieldValue is an object then the toString() method is called on it and its returned value is used as the value for the field enclosed in parenthesis.

  Throws:
    `RuntimeOperationsException` - for illegal value for field Names or field Values. If the descriptor string fails for any reason, this exception will be thrown.

Overview | Package | Class | Tree | Deprecated | Index | Help
| J2EE1.4 SDK
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature

Copyright 2003 Sun Microsystems, Inc. All rights reserved.